# 教程

🆕 请参阅参考 [Resources](./resources.md) 以获取在网络上收集的各种 XState 资源的最新列表！

## 文章

- [XState - a TypeScript state machine with a lot of features](http://realfiction.net/2019/01/30/xstate-a-typescript-state-machine-with-a-lot-of-features) by Frank Quednau
  - An overview of creating state machines with XState and TypeScript
  - Includes a [full React example](https://github.com/flq/test-of-xstate)
- [Creating a Complex IVR System with Ease with XState](https://www.nexmo.com/blog/2019/06/20/creating-a-complex-ivr-system-with-ease-with-xstate/) by Yonatan Mevorach
  - Tutorial on how to create an IVR (interactive voice response) system with XState, Express, and Nexmo
- [My love letter to XState and statecharts ♥](https://dev.to/timdeschryver/my-love-letter-to-xstate-and-statecharts-287b) by [Tim Deschryver](https://dev.to/timdeschryver)
  - Overview of the benefits and experience of developing with XState
  - Includes a [demo `xstate-table` project](https://github.com/timdeschryver/xstate-table) using the exact same XState machine in the following languages:
    - [Angular](https://stackblitz.com/edit/xstate-angular-table)
    - [React](https://codesandbox.io/s/1dtmk)
    - [Svelte](https://codesandbox.io/s/yb6lq)
    - [Vue](https://codesandbox.io/s/707t4)
- [Finite State Machines in React JS using XState](https://www.skcript.com/svr/finite-state-machines-in-react-js-using-xstate/) by [Sooraj Nair](https://www.linkedin.com/in/sooraj-nair-a81543172/)
  - Explanation of what finite state machines are, as well as a tutorial on building a simple authentication flow with React (class components)
  - Has screenshots to generated machine visualizations
- [Vuex + XState](https://medium.com/@brockreece/vuex-xstate-4f9ea23bb24e) by [Brock Reece](https://medium.com/@brockreece)
  - A nice, short article on using XState with Vuex
  - Doesn't use [services](../guides/interpretation.md), but uses a plain `Machine(...)`.
  - See [the Vue recipes](../recipes/vue.md) for more information on integrating XState with Vue
- [Getting Started with XState](https://www.vietnguyen.site/getting-started-with-xstate/) by [Viet Nguyen](https://www.vietnguyen.site)
  - An example of using XState with NextJS
- [PureUI Chatbot with Xstate + React](https://dev.to/cris_o/pure-ui-using-xstate-and-reactjs-5em7)
  - builds a chatbot using xState and reactjs

## 视频

- [▶ Introduction to XState](https://www.youtube.com/watch?v=73Ch_EL4YVc) by Jon Bellah
- [▶ Introduction to State Machines Using XState](https://egghead.io/courses/introduction-to-state-machines-using-xstate) by Kyle Shevlin
- [▶ Let's learn state machines with David K. Piano - Learn With Jason](https://www.youtube.com/watch?v=czi24DqUfSA) with Jason Lengstorf
- [▶ State Machines (playlist)](https://www.youtube.com/watch?v=iDZxjJYMOUQ&list=PL8fumNHsC-3MFSqjrn603qkkK6KY3PBDZ) by Leigh Halliday
  1. [▶ XState - An Introduction - Finite State Machines in React](https://www.youtube.com/watch?v=iDZxjJYMOUQ&list=PL8fumNHsC-3MFSqjrn603qkkK6KY3PBDZ&index=1)
  2. [▶ XState - Data Loading Service - Finite State Machines in React](https://www.youtube.com/watch?v=XaHk9vhmus4&list=PL8fumNHsC-3MFSqjrn603qkkK6KY3PBDZ&index=2)
  3. [▶ XState - Video Player & Nested States - Finite State Machines in React](https://www.youtube.com/watch?v=d8V5vcZOQe4&list=PL8fumNHsC-3MFSqjrn603qkkK6KY3PBDZ&index=3)
- [▶ Managing Complex UI with XState](https://www.youtube.com/watch?v=i0rhP7TTQBg) by Xavier Lozinguez at React NYC
  - [Demo (CodeSandbox)](https://codesandbox.io/s/k06kloqzyo)
- [▶ Drawing Apps with XState V4](https://www.youtube.com/watch?v=jw03YmNffks) by Shawn McKay at the ReactJS Vancouver Meetup
- [▶ Standing on the Shoulders of Giants. Development With XState](https://www.youtube.com/watch?v=GuzcWkVrqLg) by Brad Woods
- [▶ Using Finite State Machines To Develop Your React App](https://www.youtube.com/watch?v=p_md9SZEKV8) by Lucas Reis at React NYC
- [▶ Quick Introduction to XState](https://www.youtube.com/watch?v=QUPEDXp4ljs) by Bhargav Ponnapalli
- [▶ How XState Helps You Think](https://www.youtube.com/watch?v=JfU3uPU7Q9Q) by Swizec Teller
- [▶ Improving State Representation by using XState in React](https://www.youtube.com/watch?v=hG3UHNCUdzQ) by Jon Condon
- [▶ MobX with XState](https://www.youtube.com/watch?v=Va_d5JmDHnA) by Daria Whitecastle at React Denver
- [▶ Rambling Thoughts on React and Finite State Machines](https://www.youtube.com/watch?v=WbhpQXH7XMw) by Ryan Florence
- [▶ Intro to State Machines in JavaScript - Part 1](https://www.youtube.com/watch?v=HBJ-8YEw39E) by David Lopez
  - [▶ Part 2](https://www.youtube.com/watch?v=dB1tGv2WGBI)
- [▶ State Machines Meet React Hooks](https://www.youtube.com/watch?v=ioh7aqrBcs0) by Zain Fathoni at JSConf.Asia 2019
